make V=1 or Q= for verbose?
Status: Closed   

Priority: Normal   

Assignee:    

Description

This is a question about make V=1 and make Q=.

Seeing the code, it seems make V=1 is for a kind of official use rather than make Q=.

https://github.com/ruby/ruby/blob/0bab4c4addef3421f8ff1c45564f4a392b860f15/common.mk#L9-L15

However when I tested how to log between make V=1 and make Q= on the latest master

0bab4c4addef3421f8ff1c45564f4a392b860f15. Against my expectation, the result was that the Q= printed more log than V=1. I would

attach the log files. Is it intentional?

autoconf 

./configure

make Q= 2>&1 | tee make_q.log

 
autoconf

./configure

make V=1 2>&1 | tee make_v1.log

 
$ diff make_q.log make_v1.log | head -10

19d18

< compiling ./main.c

21d19

< compiling dmydln.c

23d20

< generating id.h

27d23

< generating miniprelude.c

31d26

< compiling miniinit.c

 I am trying to find which part prints the ...ing <file path> lines to the log. The lines below might be clue. But I am not sure about it so

far due to my limitation of understanding Makefile syntax.

https://github.com/ruby/ruby/blob/0bab4c4addef3421f8ff1c45564f4a392b860f15/template/Makefile.in#L9

ECHO1 = $(V:1=$n)

 https://github.com/ruby/ruby/blob/0bab4c4addef3421f8ff1c45564f4a392b860f15/template/exts.mk.tmpl#L6

ECHO1 = $(V:1=$n)

ECHO = $(ECHO1:0=@echo)

History

#1 - 04/27/2022 12:34 PM - jaruga (Jun Aruga)

I would attach the log files.

 Oh I couldn't upload the log files due to "Internal Server Error" on Redmine..

#2 - 04/28/2022 03:44 PM - jaruga (Jun Aruga)

- File make_q.log added

- File make_v1.log added

07/21/2025 1/3

https://github.com/ruby/ruby/blob/0bab4c4addef3421f8ff1c45564f4a392b860f15/common.mk#L9-L15
https://github.com/ruby/ruby/blob/0bab4c4addef3421f8ff1c45564f4a392b860f15/template/Makefile.in#L9
https://github.com/ruby/ruby/blob/0bab4c4addef3421f8ff1c45564f4a392b860f15/template/exts.mk.tmpl#L6


#3 - 04/28/2022 03:45 PM - jaruga (Jun Aruga)

Oh I couldn't upload the log files due to "Internal Server Error" on Redmine..

 I uploaded the log files now, as the internal server error issue above was fixed.

#4 - 05/02/2022 05:57 PM - jaruga (Jun Aruga)

- File make_main_o_q_debug.log added

- File make_main_o_v1_debug.log added

- Status changed from Open to Closed

To simplify the difference, I tested only running the target $(MAINOBJ) in uncommon.mk, adding the debug log below in uncommon.mk.

$(MAINOBJ): $(srcdir)/$(MAINSRC)

    @echo "n: $(n)"

    @echo "V: $(V)"

    @echo "Q: $(Q)"

    @echo "ECHO1: $(ECHO1)"

    @echo "ECHO0: $(ECHO0)"

    @echo "ECHO: $(ECHO)"

    $(ECHO) compiling $(srcdir)/$(MAINSRC)

    $(Q) $(CC) $(MAINCPPFLAGS) $(CFLAGS) $(XCFLAGS) $(CPPFLAGS) $(COUTFLAG)$@ -c $(CSRCFLAG)$(srcdir)/$(MAINSR

C)

 I executed as follows.

git clean -fdx

autoconf 

./configure

 In the case of Q=, the compiling ./main.c is printed.

rm main.o

make Q= main.o 2>&1 | tee make_main_o_q_debug.log

n: :

V: 0

Q: 

ECHO1: 0

ECHO0: echo

ECHO: @echo

compiling ./main.c

gcc  -O3 -fno-fast-math -ggdb3 -Wall -Wextra -Werror=deprecated-declarations -Werror=div-by-zero -Werror=dupli

cated-cond -Werror=implicit-function-declaration -Werror=implicit-int -Werror=misleading-indentation -Werror=p

ointer-arith -Werror=write-strings -Werror=old-style-definition -Wimplicit-fallthrough=0 -Wmissing-noreturn -W

no-cast-function-type -Wno-constant-logical-operand -Wno-long-long -Wno-missing-field-initializers -Wno-overle

ngth-strings -Wno-packed-bitfield-compat -Wno-parentheses-equality -Wno-self-assign -Wno-tautological-compare 

-Wno-unused-parameter -Wno-unused-value -Wsuggest-attribute=format -Wsuggest-attribute=noreturn -Wunused-varia

ble -Werror=undef -std=gnu99  -D_FORTIFY_SOURCE=2 -fstack-protector-strong -fno-strict-overflow -DRUBY_DEVEL=1

 -fvisibility=hidden -fexcess-precision=standard -DRUBY_EXPORT -fPIE -I. -I.ext/include/x86_64-linux -I./inclu

de -I. -I./enc/unicode/14.0.0    -o main.o -c ./main.c

 In the case of V=1, the compiling ./main.c is not printed.

rm main.o

make V=1 main.o 2>&1 | tee make_main_o_v1_debug.log

n: :

V: 1

Q: 

ECHO1: :

ECHO0: :

ECHO: @:

gcc  -O3 -fno-fast-math -ggdb3 -Wall -Wextra -Werror=deprecated-declarations -Werror=div-by-zero -Werror=dupli

cated-cond -Werror=implicit-function-declaration -Werror=implicit-int -Werror=misleading-indentation -Werror=p

ointer-arith -Werror=write-strings -Werror=old-style-definition -Wimplicit-fallthrough=0 -Wmissing-noreturn -W

no-cast-function-type -Wno-constant-logical-operand -Wno-long-long -Wno-missing-field-initializers -Wno-overle

ngth-strings -Wno-packed-bitfield-compat -Wno-parentheses-equality -Wno-self-assign -Wno-tautological-compare 

-Wno-unused-parameter -Wno-unused-value -Wsuggest-attribute=format -Wsuggest-attribute=noreturn -Wunused-varia

ble -Werror=undef -std=gnu99  -D_FORTIFY_SOURCE=2 -fstack-protector-strong -fno-strict-overflow -DRUBY_DEVEL=1

 -fvisibility=hidden -fexcess-precision=standard -DRUBY_EXPORT -fPIE -I. -I.ext/include/x86_64-linux -I./inclu

de -I. -I./enc/unicode/14.0.0    -o main.o -c ./main.c
 The difference comes from the ECHO1 setting in Makefile.in. In my assumption on the line, if V equals 1 the ECHO1 is set as $n (= :), otherwise

ECHO1 is set as the value of V. I couldn't find the this syntax in the GNU make official document.

https://github.com/ruby/ruby/blob/049303eff39d654f198b441e8e5f0f5b75a25e74/template/Makefile.in#L9

ECHO1 = $(V:1=$n)

 So, my conclusion is the current logic for V and Q is intentional. And I would close this ticket.

#5 - 05/02/2022 06:05 PM - jaruga (Jun Aruga)

- Status changed from Closed to Feedback

So, my conclusion is the current logic for V and Q is intentional. And I would close this ticket.

 Sorry for confusion. I changed my mind. I want to make V=1 print the logs like current Q=, because I think when users set make V=1, they expect

verbose.

#6 - 05/02/2022 07:18 PM - jaruga (Jun Aruga)

I sent the PR https://github.com/ruby/ruby/pull/5875.

#7 - 05/03/2022 04:59 PM - nobu (Nobuyoshi Nakada)

Do not use Q=.

Q, Q1 and V1 are intermediate variables.

You may want to set ECHO0=echo unconditionally.

#8 - 05/04/2022 04:47 PM - jaruga (Jun Aruga)

- Status changed from Feedback to Closed

nobu (Nobuyoshi Nakada) wrote in #note-7:

Do not use Q=.

Q, Q1 and V1 are intermediate variables.

You may want to set ECHO0=echo unconditionally.

 Thanks for the info. I see a little bit difference of printed logs between make Q=, make install Q= and make V=1 ECHO0=echo and make install V=1

ECHO0=echo. But that's fine with me. I will use the V=1 ECHO0=echo.

Files

make_q.log 442 KB 04/28/2022 jaruga (Jun Aruga)

make_v1.log 440 KB 04/28/2022 jaruga (Jun Aruga)

make_main_o_q_debug.log 1001 Bytes 05/02/2022 jaruga (Jun Aruga)

make_main_o_v1_debug.log 976 Bytes 05/02/2022 jaruga (Jun Aruga)
